diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/wifi-backward-compatibility.cc ns-3.36/examples/wireless/wifi-backward-compatibility.cc
--- ns-3.35/examples/wireless/wifi-backward-compatibility.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/wifi-backward-compatibility.cc	2022-04-30 18:23:57.726733000 -0700
@@ -22,6 +22,8 @@
 #include "ns3/config.h"
 #include "ns3/uinteger.h"
 #include "ns3/boolean.h"
+#include "ns3/enum.h"
+#include "ns3/tuple.h"
 #include "ns3/log.h"
 #include "ns3/yans-wifi-helper.h"
 #include "ns3/ssid.h"
@@ -37,57 +39,67 @@
 // network where the AP and the station use different 802.11 standards.
 //
 // It outputs the throughput for a given configuration: user can specify
-// the 802.11 versions for the AT and the station as well as their rate
+// the 802.11 versions for the AP and the station as well as their rate
 // adaptation algorithms. It also allows to decide whether the station,
 // the AP or both has/have traffic to send.
 //
 // Example for an IEEE 802.11ac station sending traffic to an 802.11a AP using Ideal rate adaptation algorithm:
-// ./waf --run "wifi-backward-compatibility --apVersion=80211a --staVersion=80211ac --staRaa=Ideal"
+// ./ns3 run "wifi-backward-compatibility --apVersion=80211a --staVersion=80211ac --staRaa=Ideal"
 
 using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE ("wifi-backward-compatibility");
 
-WifiStandard ConvertStringToStandard (std::string version)
+std::pair<WifiStandard, WifiPhyBand> ConvertStringToStandardAndBand (std::string version)
 {
   WifiStandard standard = WIFI_STANDARD_80211a;
+  WifiPhyBand band = WIFI_PHY_BAND_5GHZ;
   if (version == "80211a")
     {
       standard = WIFI_STANDARD_80211a;
+      band = WIFI_PHY_BAND_5GHZ;
     }
   else if (version == "80211b")
     {
       standard = WIFI_STANDARD_80211b;
+      band = WIFI_PHY_BAND_2_4GHZ;
     }
   else if (version == "80211g")
     {
       standard = WIFI_STANDARD_80211g;
+      band = WIFI_PHY_BAND_2_4GHZ;
     }
   else if (version == "80211p")
     {
       standard = WIFI_STANDARD_80211p;
+      band = WIFI_PHY_BAND_5GHZ;
     }
   else if (version == "80211n_2_4GHZ")
     {
-      standard = WIFI_STANDARD_80211n_2_4GHZ;
+      standard = WIFI_STANDARD_80211n;
+      band = WIFI_PHY_BAND_2_4GHZ;
     }
   else if (version == "80211n_5GHZ")
     {
-      standard = WIFI_STANDARD_80211n_5GHZ;
+      standard = WIFI_STANDARD_80211n;
+      band = WIFI_PHY_BAND_5GHZ;
     }
   else if (version == "80211ac")
     {
       standard = WIFI_STANDARD_80211ac;
+      band = WIFI_PHY_BAND_5GHZ;
     }
   else if (version == "80211ax_2_4GHZ")
     {
-      standard = WIFI_STANDARD_80211ax_2_4GHZ;
+      standard = WIFI_STANDARD_80211ax;
+      band = WIFI_PHY_BAND_2_4GHZ;
     }
   else if (version == "80211ax_5GHZ")
     {
-      standard = WIFI_STANDARD_80211ax_5GHZ;
+      standard = WIFI_STANDARD_80211ax;
+      band = WIFI_PHY_BAND_5GHZ;
     }
-  return standard;
+  return {standard, band};
 }
 
 int main (int argc, char *argv[])
@@ -123,8 +135,10 @@
   WifiMacHelper mac;
   WifiHelper wifi;
   Ssid ssid = Ssid ("ns3");
+  TupleValue<UintegerValue, UintegerValue, EnumValue, UintegerValue> channelValue;
 
-  wifi.SetStandard (ConvertStringToStandard (staVersion));
+  const auto& [staStandard, staBand] = ConvertStringToStandardAndBand (staVersion);
+  wifi.SetStandard (staStandard);
   wifi.SetRemoteStationManager ("ns3::" + staRaa + "WifiManager");
 
   mac.SetType ("ns3::StaWifiMac",
@@ -132,16 +146,15 @@
                "Ssid", SsidValue (ssid));
 
   //Workaround needed as long as we do not fully support channel bonding
-  if (staVersion == "80211ac")
-    {
-      phy.Set ("ChannelWidth", UintegerValue (20));
-      phy.Set ("Frequency", UintegerValue (5180));
-    }
+  uint16_t width = (staVersion == "80211ac" ? 20 : 0);
+  channelValue.Set (WifiPhy::ChannelTuple {0, width, staBand, 0});
+  phy.Set ("ChannelSettings", channelValue);
 
   NetDeviceContainer staDevice;
   staDevice = wifi.Install (phy, mac, wifiStaNode);
 
-  wifi.SetStandard (ConvertStringToStandard (apVersion));
+  const auto& [apStandard, apBand] = ConvertStringToStandardAndBand (apVersion);
+  wifi.SetStandard (apStandard);
   wifi.SetRemoteStationManager ("ns3::" + apRaa + "WifiManager");
 
   mac.SetType ("ns3::ApWifiMac",
@@ -149,11 +162,9 @@
                "Ssid", SsidValue (ssid));
 
   //Workaround needed as long as we do not fully support channel bonding
-  if (apVersion == "80211ac")
-    {
-      phy.Set ("ChannelWidth", UintegerValue (20));
-      phy.Set ("Frequency", UintegerValue (5180));
-    }
+  width = (apVersion == "80211ac" ? 20 : 0);
+  channelValue.Set (WifiPhy::ChannelTuple {0, width, apBand, 0});
+  phy.Set ("ChannelSettings", channelValue);
 
   NetDeviceContainer apDevice;
   apDevice = wifi.Install (phy, mac, wifiApNode);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/wifi-blockack.cc ns-3.36/examples/wireless/wifi-blockack.cc
--- ns-3.35/examples/wireless/wifi-blockack.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/wifi-blockack.cc	2022-04-30 18:23:57.726733000 -0700
@@ -19,7 +19,7 @@
  */
 
 /**
- * This is a simple example in order to show how 802.11e compressed block ack mechanism could be used.
+ * This is a simple example in order to show how 802.11n compressed block ack mechanism could be used.
  *
  * Network topology:
  *
@@ -78,9 +78,10 @@
   phy.SetChannel (channel.Create ());
 
   WifiHelper wifi;
+  wifi.SetStandard (WIFI_STANDARD_80211n);
   WifiMacHelper mac;
   /* disable fragmentation */
-  wifi.SetRemoteStationManager ("ns3::AarfWifiManager", "FragmentationThreshold", UintegerValue (2500));
+  wifi.SetRemoteStationManager ("ns3::IdealWifiManager", "FragmentationThreshold", UintegerValue (2500));
 
   Ssid ssid ("My-network");
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/wifi-clear-channel-cmu.cc ns-3.36/examples/wireless/wifi-clear-channel-cmu.cc
--- ns-3.35/examples/wireless/wifi-clear-channel-cmu.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/wifi-clear-channel-cmu.cc	2022-04-30 18:23:57.726733000 -0700
@@ -35,23 +35,66 @@
 
 NS_LOG_COMPONENT_DEFINE ("ClearChannelCmu");
 
+/**
+ * WiFi clear channel cmu experiment class.
+ * 
+ * It handles the creation and run of an experiment.
+ */
 class Experiment
 {
 public:
   Experiment ();
+  /**
+   * Constructor.
+   * \param name The name of the experiment.
+   */
   Experiment (std::string name);
+  /**
+   * Run an experiment.
+   * \param wifi      //!< The WifiHelper class.
+   * \param wifiPhy   //!< The YansWifiPhyHelper class.
+   * \param wifiMac   //!< The WifiMacHelper class.
+   * \param wifiChannel //!< The YansWifiChannelHelper class.
+   * \return the number of received packets. 
+   */
   uint32_t Run (const WifiHelper &wifi, const YansWifiPhyHelper &wifiPhy,
                 const WifiMacHelper &wifiMac, const YansWifiChannelHelper &wifiChannel);
 private:
+  /**
+   * Receive a packet.
+   * \param socket The recieving socket.
+   */
   void ReceivePacket (Ptr<Socket> socket);
+  /**
+   * Set the position of a node.
+   * \param node The node.
+   * \param position The position of the node.
+   */
   void SetPosition (Ptr<Node> node, Vector position);
+  /**
+   * Get the position of a node.
+   * \param node The node.
+   * \return the position of the node.
+   */
   Vector GetPosition (Ptr<Node> node);
+  /**
+   * Setup the receiving socket.
+   * \param node The receiving node.
+   * \return the socket.
+   */
   Ptr<Socket> SetupPacketReceive (Ptr<Node> node);
+  /**
+   * Generate the traffic.
+   * \param socket The sending socket.
+   * \param pktSize The packet size.
+   * \param pktCount The number of packets to send.
+   * \param pktInterval The time between packets.
+   */
   void GenerateTraffic (Ptr<Socket> socket, uint32_t pktSize,
                         uint32_t pktCount, Time pktInterval );
 
-  uint32_t m_pktsTotal;
-  Gnuplot2dDataset m_output;
+  uint32_t m_pktsTotal;       //!< Total number of received packets
+  Gnuplot2dDataset m_output;  //!< Output dataset.
 };
 
 Experiment::Experiment ()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/wifi-he-network.cc ns-3.36/examples/wireless/wifi-he-network.cc
--- ns-3.35/examples/wireless/wifi-he-network.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/wifi-he-network.cc	2022-04-30 18:23:57.726733000 -0700
@@ -74,6 +74,8 @@
   double frequency {5}; //whether 2.4, 5 or 6 GHz
   std::size_t nStations {1};
   std::string dlAckSeqType {"NO-OFDMA"};
+  bool enableUlOfdma {false};
+  bool enableBsrp {false};
   int mcs {-1}; // -1 indicates an unset value
   uint32_t payloadSize = 700; // must fit in the max TX duration when transmitting at MCS 0 over an RU of 26 tones
   std::string phyModel {"Yans"};
@@ -90,6 +92,8 @@
   cmd.AddValue ("nStations", "Number of non-AP HE stations", nStations);
   cmd.AddValue ("dlAckType", "Ack sequence type for DL OFDMA (NO-OFDMA, ACK-SU-FORMAT, MU-BAR, AGGR-MU-BAR)",
                 dlAckSeqType);
+  cmd.AddValue ("enableUlOfdma", "Enable UL OFDMA (useful if DL OFDMA is enabled and TCP is used)", enableUlOfdma);
+  cmd.AddValue ("enableBsrp", "Enable BSRP (useful if DL and UL OFDMA are enabled and TCP is used)", enableBsrp);
   cmd.AddValue ("mcs", "if set, limit testing to a specific MCS (0-11)", mcs);
   cmd.AddValue ("payloadSize", "The application payload size in bytes", payloadSize);
   cmd.AddValue ("phyModel", "PHY model to use when OFDMA is disabled (Yans or Spectrum). If OFDMA is enabled then Spectrum is automatically selected", phyModel);
@@ -167,19 +171,23 @@
               NetDeviceContainer apDevice, staDevices;
               WifiMacHelper mac;
               WifiHelper wifi;
+              std::string channelStr ("{0, " + std::to_string (channelWidth) + ", ");
 
               if (frequency == 6)
                 {
-                  wifi.SetStandard (WIFI_STANDARD_80211ax_6GHZ);
+                  wifi.SetStandard (WIFI_STANDARD_80211ax);
+                  channelStr += "BAND_6GHZ, 0}";
                   Config::SetDefault ("ns3::LogDistancePropagationLossModel::ReferenceLoss", DoubleValue (48));
                 }
               else if (frequency == 5)
                 {
-                  wifi.SetStandard (WIFI_STANDARD_80211ax_5GHZ);
+                  wifi.SetStandard (WIFI_STANDARD_80211ax);
+                  channelStr += "BAND_5GHZ, 0}";
                 }
               else if (frequency == 2.4)
                 {
-                  wifi.SetStandard (WIFI_STANDARD_80211ax_2_4GHZ);
+                  wifi.SetStandard (WIFI_STANDARD_80211ax);
+                  channelStr += "BAND_2_4GHZ, 0}";
                   Config::SetDefault ("ns3::LogDistancePropagationLossModel::ReferenceLoss", DoubleValue (40));
                 }
               else
@@ -210,19 +218,18 @@
 
                   mac.SetType ("ns3::StaWifiMac",
                               "Ssid", SsidValue (ssid));
-                  phy.Set ("ChannelWidth", UintegerValue (channelWidth));
+                  phy.Set ("ChannelSettings", StringValue (channelStr));
                   staDevices = wifi.Install (phy, mac, wifiStaNodes);
 
                   if (dlAckSeqType != "NO-OFDMA")
                     {
                       mac.SetMultiUserScheduler ("ns3::RrMultiUserScheduler",
-                                                "EnableUlOfdma", BooleanValue (false),
-                                                "EnableBsrp", BooleanValue (false));
+                                                "EnableUlOfdma", BooleanValue (enableUlOfdma),
+                                                "EnableBsrp", BooleanValue (enableBsrp));
                     }
                   mac.SetType ("ns3::ApWifiMac",
                               "EnableBeaconJitter", BooleanValue (false),
                               "Ssid", SsidValue (ssid));
-                  phy.Set ("ChannelWidth", UintegerValue (channelWidth));
                   apDevice = wifi.Install (phy, mac, wifiApNode);
                 }
               else
@@ -234,13 +241,12 @@
 
                   mac.SetType ("ns3::StaWifiMac",
                               "Ssid", SsidValue (ssid));
-                  phy.Set ("ChannelWidth", UintegerValue (channelWidth));
+                  phy.Set ("ChannelSettings", StringValue (channelStr));
                   staDevices = wifi.Install (phy, mac, wifiStaNodes);
 
                   mac.SetType ("ns3::ApWifiMac",
                               "EnableBeaconJitter", BooleanValue (false),
                               "Ssid", SsidValue (ssid));
-                  phy.Set ("ChannelWidth", UintegerValue (channelWidth));
                   apDevice = wifi.Install (phy, mac, wifiApNode);
                 }
 
@@ -380,7 +386,7 @@
                 {
                   previous = throughput;
                 }
-              else
+              else if (throughput > 0)
                 {
                   NS_LOG_ERROR ("Obtained throughput " << throughput << " is not expected!");
                   exit (1);
@@ -390,7 +396,7 @@
                 {
                   prevThroughput [index] = throughput;
                 }
-              else
+              else if (throughput > 0)
                 {
                   NS_LOG_ERROR ("Obtained throughput " << throughput << " is not expected!");
                   exit (1);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/wifi-ht-network.cc ns-3.36/examples/wireless/wifi-ht-network.cc
--- ns-3.35/examples/wireless/wifi-ht-network.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/wifi-ht-network.cc	2022-04-30 18:23:57.726733000 -0700
@@ -25,6 +25,8 @@
 #include "ns3/boolean.h"
 #include "ns3/double.h"
 #include "ns3/string.h"
+#include "ns3/enum.h"
+#include "ns3/tuple.h"
 #include "ns3/log.h"
 #include "ns3/yans-wifi-helper.h"
 #include "ns3/ssid.h"
@@ -128,13 +130,14 @@
 
               WifiMacHelper mac;
               WifiHelper wifi;
+
               if (frequency == 5.0)
                 {
-                  wifi.SetStandard (WIFI_STANDARD_80211n_5GHZ);
+                  wifi.SetStandard (WIFI_STANDARD_80211n);
                 }
               else if (frequency == 2.4)
                 {
-                  wifi.SetStandard (WIFI_STANDARD_80211n_2_4GHZ);
+                  wifi.SetStandard (WIFI_STANDARD_80211n);
                   Config::SetDefault ("ns3::LogDistancePropagationLossModel::ReferenceLoss", DoubleValue (40.046));
                 }
               else
@@ -149,10 +152,13 @@
                                             "ControlMode", StringValue (oss.str ()));
 
               Ssid ssid = Ssid ("ns3-80211n");
+              TupleValue<UintegerValue, UintegerValue, EnumValue, UintegerValue> channelValue;
+              WifiPhyBand band = (frequency == 5.0 ? WIFI_PHY_BAND_5GHZ : WIFI_PHY_BAND_2_4GHZ);
+              channelValue.Set (WifiPhy::ChannelTuple {0, channelWidth, band, 0});
 
               mac.SetType ("ns3::StaWifiMac",
                            "Ssid", SsidValue (ssid));
-              phy.Set ("ChannelWidth", UintegerValue (channelWidth));
+              phy.Set ("ChannelSettings", channelValue);
 
               NetDeviceContainer staDevice;
               staDevice = wifi.Install (phy, mac, wifiStaNode);
@@ -160,7 +166,6 @@
               mac.SetType ("ns3::ApWifiMac",
                            "EnableBeaconJitter", BooleanValue (false),
                            "Ssid", SsidValue (ssid));
-              phy.Set ("ChannelWidth", UintegerValue (channelWidth));
 
               NetDeviceContainer apDevice;
               apDevice = wifi.Install (phy, mac, wifiApNode);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/wifi-mixed-network.cc ns-3.36/examples/wireless/wifi-mixed-network.cc
--- ns-3.35/examples/wireless/wifi-mixed-network.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/wifi-mixed-network.cc	2022-04-30 18:23:57.726733000 -0700
@@ -55,35 +55,41 @@
 // short slot time are only observed in a g only configuration.
 //
 // The user can also select the payload size and can choose either an UDP or a TCP connection.
-// Example: ./waf --run "wifi-mixed-network --isUdp=1"
+// Example: ./ns3 run "wifi-mixed-network --isUdp=1"
 
 using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE ("MixedNetwork");
 
+/** Parameters */
 struct Parameters
 {
-  std::string testName;
-  bool enableErpProtection;
-  std::string erpProtectionMode;
-  bool enableShortSlotTime;
-  bool enableShortPhyPreamble;
-  WifiStandard apType;
-  uint32_t nWifiB;
-  bool bHasTraffic;
-  uint32_t nWifiG;
-  bool gHasTraffic;
-  uint32_t nWifiN;
-  bool nHasTraffic;
-  bool isUdp;
-  uint32_t payloadSize;
-  double simulationTime;
+  std::string testName;             //!< Test name
+  bool enableErpProtection;         //!< True to enable ERP protection
+  std::string erpProtectionMode;    //!< ERP protection mode
+  bool enableShortSlotTime;         //!< True to enable short slot time
+  bool enableShortPhyPreamble;      //!< True to enable short PHY preamble
+  WifiStandard apType;              //!< Wifi standard for AP
+  uint32_t nWifiB;                  //!< Number of 802.11b stations
+  bool bHasTraffic;                 //!< True if 802.11b stations generate traffic
+  uint32_t nWifiG;                  //!< Number of 802.11g stations
+  bool gHasTraffic;                 //!< True if 802.11g stations generate traffic
+  uint32_t nWifiN;                  //!< Number of 802.11n stations
+  bool nHasTraffic;                 //!< True if 802.11n stations generate traffic
+  bool isUdp;                       //!< True to generate UDP traffic
+  uint32_t payloadSize;             //!< Payload size in bytes
+  double simulationTime;            //!< Simulation time in seconds
 };
 
 class Experiment
 {
 public:
   Experiment ();
+  /**
+   * Run an experiment with the given parameters
+   * \param params the given parameters
+   * \return the throughput
+   */
   double Run (Parameters params);
 };
 
@@ -99,7 +105,7 @@
     {
       apTypeString = "WIFI_STANDARD_80211g";
     }
-  else if (params.apType == WIFI_STANDARD_80211n_2_4GHZ)
+  else if (params.apType == WIFI_STANDARD_80211n)
     {
       apTypeString = "WIFI_STANDARD_80211n_2_4GHZ";
     }
@@ -167,7 +173,7 @@
   gStaDevice = wifi.Install (phy, mac, wifiGStaNodes);
 
   // 802.11b/g/n STA
-  wifi.SetStandard (WIFI_STANDARD_80211n_2_4GHZ);
+  wifi.SetStandard (WIFI_STANDARD_80211n);
   NetDeviceContainer nStaDevice;
   mac.SetType ("ns3::StaWifiMac",
                "Ssid", SsidValue (ssid),
@@ -187,7 +193,7 @@
   apDevice = wifi.Install (phy, mac, wifiApNode);
 
   // Set TXOP limit
-  if (params.apType == WIFI_STANDARD_80211n_2_4GHZ)
+  if (params.apType == WIFI_STANDARD_80211n)
     {
       Ptr<NetDevice> dev = wifiApNode.Get (0)->GetDevice (0);
       Ptr<WifiNetDevice> wifi_dev = DynamicCast<WifiNetDevice> (dev);
@@ -471,7 +477,7 @@
   params.enableErpProtection = false;
   params.enableShortSlotTime = false;
   params.enableShortPhyPreamble = false;
-  params.apType = WIFI_STANDARD_80211n_2_4GHZ;
+  params.apType = WIFI_STANDARD_80211n;
   params.nWifiB = 0;
   params.bHasTraffic = false;
   params.nWifiG = 0;
@@ -490,7 +496,7 @@
   params.enableErpProtection = false;
   params.enableShortSlotTime = false;
   params.enableShortPhyPreamble = false;
-  params.apType = WIFI_STANDARD_80211n_2_4GHZ;
+  params.apType = WIFI_STANDARD_80211n;
   params.nWifiB = 0;
   params.bHasTraffic = false;
   params.nWifiG = 1;
